; InvertRGB.asm   For NASM

; Similar to Bin3 but using a DLL instead
; Demonstrates reserving named space in a DLL

; Inverts an RGB Array

; VB
; Private Declare Sub InvertRGB Lib "InvertRGB.dll" _
; (ByVal lpArray As Long, ByVal PICW As Long, ByVal PICH As Long)


[SECTION .bss] 
PtrArray resd 1    ; Reserve dword. 4 bytes
PICW     resd 1    ; Number of RGB triples
PICH     resd 1
IY       resd 1

; Standard Win32 statements
SEGMENT code Use32
GLOBAL _DllMain
_DllMain:   
    mov eax,1
ret 12
        

; Make InvertRGB available to VB
GLOBAL InvertRGB
InvertRGB:
    
    push ebp
    mov ebp,esp
    push esi
    push edi
    push ebx

    ; Get input parameters
    mov eax,[ebp+8]       ; Pick up param 1
    mov [PtrArray],eax    ; Store the address in named space
                          ; PtrArray, Note []
    
    mov eax,[ebp+12]      ; Pick up 2nd param
    mov [PICW],eax        ; store it
    
    mov eax,[ebp+16]      ; Pick up 3rd Param
    mov [PICH],eax        ; store it

;    mov ecx,100000       ; Include these 3 lines for max speed
;NN:                      ; see also below  
;    push ecx

    mov ecx,[PICH]        ; Set ecx to the number of Y-lines
    
ForY:
    push ecx              ; Save Y-lines in stack
    
    mov[IY],ecx           ; Save the current Y-line
    
    mov ecx,[PICW]        ; Set ecx to number of X-position
ForX:
    
    ; Get Addr  Addr = PtrArray + 3 * (IY-1)*PICW + 3*(IX-1)
    ;                = PtrArray + 3 * [ (IY-1)*PICW + (IX-1) ]
    
    mov edi,[PtrArray]       ; edi points to x=1,y=1
    
    mov eax,[IY]
    dec eax
    mov ebx,[PICW]
    mul ebx                  ; (IY-1)*PICW
    
    mov ebx,ecx              ; IX
    dec ebx                  ; IX-1
    add eax,ebx              ; [ (IY-1)*PICW + (IX-1) ]
    mov ebx,3
    mul ebx                  ; 3 * [ (IY-1)*PICW + (IX-1) ]
    add edi,eax              ; edi -> PtrArray + 3 * [ (IY-1)*PICW + (IX-1) ]
    
    ; Invert the 3 bytes RGB (255-R,G,B)
    not byte[edi]            ; Note tell NASM we only want to invert
    not byte[edi+1]          ; a byte at [edi]
    not byte[edi+2]

    
    dec ecx                  ; All X done?  
    jnz ForX
    
    pop ecx                  ; Get Y-line back
    dec ecx                  ; All Y done?
    jnz ForY
    
 ;   pop ecx                 ; Include these 3 lines if doing 100,000
                             ; inversions in asm
 ;   dec ecx                 ; All 100,000 done?
 ;   jnz NN

GETOUT:
    pop ebx
    pop edi
    pop esi
    mov esp,ebp
    pop ebp
    ret 12      ; For 3 long input parameters
