VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00E0E0E0&
   Caption         =   "Invert RGB using a DLL"
   ClientHeight    =   6780
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   11400
   DrawStyle       =   5  'Transparent
   LinkTopic       =   "Form1"
   ScaleHeight     =   452
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   760
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Inversion DLL Test by Robert Rayment

' Invert RGB 100,000 times using a DLL
' NB An even number of inversion recovers original data
' Try 100,001

Option Base 1

DefLng A-W
DefSng X-Z

Private Declare Sub InvertRGB Lib "InvertRGB.dll" _
 (ByVal lpArray As Long, ByVal PICW As Long, ByVal PICH As Long)
 
Private Declare Function timeGetTime& Lib "winmm.dll" ()
 
 Dim RGBArray() As Byte
 Dim PICW, PICH
 
Private Sub Form_Load()


Move 100, 1000

Print " Invert an RGB array"
Print

Randomize

PICW = 3
PICH = 3
ReDim RGBArray(3 * PICW, PICH)

Print " VB Invert RGB ---------------------------------------"
Print
' Fill array before invert
FillArray

' Print array before invert
Print " Before inversion"
Print

PrintArray

'VB Invert RGB

T = timeGetTime

For N = 1 To 100000

For iy = 1 To 3
For ix = 1 To 3 * PICW Step 3
   RGBArray(ix, iy) = 255 - RGBArray(ix, iy)
   RGBArray(ix + 1, iy) = 255 - RGBArray(ix + 1, iy)
   RGBArray(ix + 2, iy) = 255 - RGBArray(ix + 2, iy)
Next ix
Next iy

Next N

VBTimes = timeGetTime - T

' Print array after invert
Print
Print
Print " After 100,000 inversions (ie 255-N)"
Print

PrintArray

Print "VB Time = "; VBTimes; " millisecs"
'-----------------------------------------------------------------
Print
Print
Print " ASM Invert RGB --------------------------------------"
Print

' Fill array before invert
FillArray

' Print array before invert
Print " Before inversion"
Print

PrintArray

lpArray = VarPtr(RGBArray(1, 1))
PICW = 3
PICH = 3

T = timeGetTime

For NN = 1 To 100000
InvertRGB lpArray, PICW, PICH
Next NN

ASMTime = timeGetTime - T

' Print array after invert
Print
Print
Print " After 100,000 inversions (ie 255-N)"
Print

PrintArray

Print "ASM Time = "; ASMTime; " millisecs"

End Sub

Private Sub FillArray()
For iy = 3 To 1 Step -1
For ix = 1 To 3 * PICW Step 3
   RGBArray(ix, iy) = (255 - iy * 100 * Rnd) And 255
   RGBArray(ix + 1, iy) = (250 - iy * 100 * (Rnd - 0.5)) And 255
   RGBArray(ix + 2, iy) = (245 - iy * 100 * Rnd) And 255
Next ix
Next iy
End Sub

Private Sub PrintArray()
For iy = 1 To 3
For ix = 1 To 3 * PICW Step 3
   Print RGBArray(ix, iy), RGBArray(ix + 1, iy), RGBArray(ix + 2, iy), ,
Next ix
Print
Next iy
End Sub

Private Sub Form_Unload(Cancel As Integer)
Unload Form1
End
End Sub
